Index: cpp/frams/util/sstring-simple.cpp
===================================================================
--- cpp/frams/util/sstring-simple.cpp	(revision 385)
+++ cpp/frams/util/sstring-simple.cpp	(revision 395)
@@ -167,9 +167,9 @@
 ///////////////////////////////////////
 
-int SString::equals(const SString& s) const
-{
-if (this==&s) return 1;
-if (len()!=s.len()) return 0;
-return !strcmp(getPtr(),s.getPtr());
+bool SString::equals(const SString& s) const
+{
+if (this==&s) return true;
+if (len()!=s.len()) return false;
+return strcmp(getPtr(),s.getPtr())==0;
 }
 
@@ -194,7 +194,7 @@
 }
 
-int SString::getNextToken (int& pos,SString &token,char separator) const
-{
-if (pos>=len()) {token=0;return 0;}
+bool SString::getNextToken (int& pos,SString &token,char separator) const
+{
+if (pos>=len()) {token=0;return false;}
 int p1=pos,p2;
 const char *t1=getPtr()+pos;
@@ -203,13 +203,13 @@
 strncpy(token.directWrite(p2-p1),t1,p2-p1);
 token.endWrite(p2-p1);
-return 1;
-}
-
-int SString::startsWith(const char *pattern) const
+return true;
+}
+
+bool SString::startsWith(const char *pattern) const
 {
 const char *t=this->c_str();
 for (;*pattern;pattern++,t++)
-	if (*t != *pattern) return 0;
-return 1;
+	if (*t != *pattern) return false;
+return true;
 }
 
Index: cpp/frams/util/sstring-simple.h
===================================================================
--- cpp/frams/util/sstring-simple.h	(revision 385)
+++ cpp/frams/util/sstring-simple.h	(revision 395)
@@ -110,7 +110,7 @@
 void operator+=(const SString&); ///< append other SString
 
-int equals(const SString &s) const; ///< TRUE if equal
-int operator==(const SString &s) const {return equals(s);} ///< TRUE if equal
-int operator!=(const SString &s) const {return !equals(s);} ///< TRUE if not equal
+bool equals(const SString &s) const; ///< TRUE if equal
+bool operator==(const SString &s) const {return equals(s);} ///< TRUE if equal
+bool operator!=(const SString &s) const {return !equals(s);} ///< TRUE if not equal
 bool operator<(const SString &s) const {return strcmp(getPtr(),s.getPtr())<1;}
 const char* operator()(int p) const {return getPtr()+p;} ///< pointer to p'th character in SString
@@ -125,9 +125,9 @@
 /// <B>pos</B> is moved accordingly.
 /// returns <B>false</B> if no more tokens are available or <B>true</B> otherwise.
-int getNextToken(int& pos,SString &token,char separator) const;
+bool getNextToken(int& pos,SString &token,char separator) const;
 
 void operator+=(char ch) {directAppend(1)[0]=ch;endAppend(1);} ///< append single character
 
-int startsWith(const char *pattern) const;
+bool startsWith(const char *pattern) const;
 char charAt(int pos) const {return operator[](pos);}
 uint32_t hash() const;
Index: cpp/frams/util/sstring.cpp
===================================================================
--- cpp/frams/util/sstring.cpp	(revision 385)
+++ cpp/frams/util/sstring.cpp	(revision 395)
@@ -333,7 +333,7 @@
 }
 
-int SString::getNextToken (int& pos,SString &token,char separator) const
-{
-if (pos>=len()) {token=0;return 0;}
+bool SString::getNextToken (int& pos,SString &token,char separator) const
+{
+if (pos>=len()) {token=0;return false;}
 int p1=pos,p2;
 const char *t1=buf->txt+pos;
@@ -342,13 +342,13 @@
 strncpy(token.directWrite(p2-p1),t1,p2-p1);
 token.endWrite(p2-p1);
-return 1;
-}
-
-int SString::startsWith(const char *pattern) const
+return true;
+}
+
+bool SString::startsWith(const char *pattern) const
 {
 const char *t=this->c_str();
 for (;*pattern;pattern++,t++)
-	if (*t != *pattern) return 0;
-return 1;
+	if (*t != *pattern) return false;
+return true;
 }
 
Index: cpp/frams/util/sstring.h
===================================================================
--- cpp/frams/util/sstring.h	(revision 385)
+++ cpp/frams/util/sstring.h	(revision 395)
@@ -171,9 +171,9 @@
 /// <B>pos</B> is moved accordingly.
 /// returns <B>false</B> if no more tokens are available or <B>true</B> otherwise.
-int getNextToken(int& pos,SString &token,char separator) const;
+bool getNextToken(int& pos,SString &token,char separator) const;
 
 void operator+=(char ch) {directAppend(1)[0]=ch;endAppend(1);} ///< append single character
 
-int startsWith(const char *pattern) const;
+bool startsWith(const char *pattern) const;
 char charAt(int pos) const {return buf->txt[pos];}
 uint32_t hash() const {return buf->hash();}