Index: /experiments/frams/foraminifera/data/scripts/forams_benthic.expdef
===================================================================
--- /experiments/frams/foraminifera/data/scripts/forams_benthic.expdef	(revision 404)
+++ /experiments/frams/foraminifera/data/scripts/forams_benthic.expdef	(revision 405)
@@ -70,9 +70,9 @@
 
 	//radius of the chamber
-        ExpParams.rads = [1.2, 0.6];
-	//inital genotypes 
-	ExpParams.genh = "//0\np:sh=1,sx=" + ExpParams.rads[0] + ",sy=" + ExpParams.rads[0] + ",sz=" + ExpParams.rads[0] + ", rz=3.14159265358979"; 
+	ExpParams.rads = [1.2, 0.6];
+	//inital genotypes
+	ExpParams.genh = "//0\np:sh=1,sx=" + ExpParams.rads[0] + ",sy=" + ExpParams.rads[0] + ",sz=" + ExpParams.rads[0] + ", rz=3.14159265358979";
 	ExpParams.gend = "//0\np:sh=1,sx=" + ExpParams.rads[1] + ",sy=" + ExpParams.rads[1] + ",sz=" + ExpParams.rads[1] + ", rz=3.14159265358979";
-        ExpParams.gend += "\nn:p=0,d=\"S\"";
+	ExpParams.gend += "\nn:p=0,d=\"S\"";
 	ExpParams.e_meta = 0.1;
 	ExpParams.feedrate = 0.5;
@@ -227,6 +227,6 @@
 function onCreaturesStep(cr)
 {
-        //TODO moving inside sediment?
-	cr.moveAbs(cr.pos_x, cr.pos_y, 0); //adjustment in z axis 
+	//TODO moving inside sediment?
+	cr.moveAbs(cr.pos_x, cr.pos_y, 0); //adjustment in z axis
 	var p = cr.getMechPart(0);
 	var n = cr.signals.receiveSet("food", ExpParams.food_range);
@@ -269,5 +269,5 @@
 	if (cr.energy > 100)
 	{
-                //TODO energy costs dependant on size
+		//TODO energy costs dependent on size
 		// cr.energy_m = cr.user2["Va"]/cr.user2["vinit"];
 	}
@@ -277,5 +277,5 @@
 		//TODO what is max age value? should there be one?
 		Populations[0].kill(cr);
-                return;
+		return;
 	}
 
@@ -283,6 +283,6 @@
 	if (cr.lifespan == cr.user2["growth_step"])
 	{
-                //TODO how size is related to the energy?
-                cr.user2["rsize"] = ExpParams.rads[cr.user2["gen"]] * Math.min(Math.max(float(cr.user2["Va"] / cr.user2["vinit"]) * 0.5, 1.0), 2.5);
+		//TODO how size is related to the energy?
+		cr.user2["rsize"] = ExpParams.rads[cr.user2["gen"]] * Math.min(Math.max(float(cr.user2["Va"] / cr.user2["vinit"]) * 0.5, 1.0), 2.5);
 		var geno = "//0\np:sh=1,sx=" + cr.user2["rsize"] + ",sy=" + cr.user2["rsize"] + ",sz=" + cr.user2["rsize"] + ", rz=3.14159265358979";
 		if (cr.user2["gen"] == 1)
@@ -291,5 +291,5 @@
 			//TODO maybe it would be nice if they rotated so the "S" would show where they are going (direction/intention)
 		}
-                var cr2 = Populations[0].add(geno);
+		var cr2 = Populations[0].add(geno);
 		cr2.energy = cr.energy;
 		setGenotype(cr2, cr.user1, cr.user2);
@@ -347,5 +347,5 @@
 	{
 		cr.user1 = [ {"vamin" : new_user1[0]["vamin"], "amin": new_user1[0]["amin"] }, {"vamin" : new_user1[1]["vamin"], "amin": new_user1[1]["amin"] }];
-	}       
+	}
 
 }
@@ -426,5 +426,5 @@
 prop:
 id:rads
-name: haploid and diploid radius
+name:Haploid and diploid radius
 type:x
 
@@ -455,5 +455,5 @@
 prop:
 id:repro_thr
-name:amount of energy initial creatures need to gather to reproduce
+name:Energy creatures need to gather to reproduce
 type:d 1 1000 1
 
@@ -583,5 +583,5 @@
 prop:
 id:foodPop
-name:food size
+name:Food size
 type:d 1 1000 10
 
@@ -592,3 +592,2 @@
 type:x
 flags:32
-
Index: /experiments/frams/foraminifera/data/scripts/forams_repro.inc
===================================================================
--- /experiments/frams/foraminifera/data/scripts/forams_repro.inc	(revision 404)
+++ /experiments/frams/foraminifera/data/scripts/forams_repro.inc	(revision 405)
@@ -108,5 +108,5 @@
 			haploids += 1;
 			e_inc_h += cr.energy;
-			size_h += ExpParams.rads[0]; //TODO change of size dependant on gene
+			size_h += ExpParams.rads[0]; //TODO change of size dependent on gene
 			vmin_h += cr.user1["vamin"];
 		}
@@ -115,5 +115,5 @@
 			diploids += 1;
 			e_inc_d += cr.energy;
-			size_d += ExpParams.rads[1]; //TODO change of size dependant on gene
+			size_d += ExpParams.rads[1]; //TODO change of size dependent on gene
 			vmin_d += cr.user1[0]["vamin"];
 		}