Index: cpp/frams/_demos/neuro_layout_test.cpp
===================================================================
--- cpp/frams/_demos/neuro_layout_test.cpp	(revision 400)
+++ cpp/frams/_demos/neuro_layout_test.cpp	(revision 408)
@@ -16,5 +16,5 @@
  Sample code: Neuron layout tester
 
- Hint: Use loader_test to extract genotypes from framsticks *.gen files:
+ Hint: Use loader_test to extract genotypes from Framsticks *.gen files:
  loader_test "data/walking.gen" "Walking Lizard" | neuro_layout_test -
 */
Index: cpp/frams/genetics/f1/conv_f1.h
===================================================================
--- cpp/frams/genetics/f1/conv_f1.h	(revision 400)
+++ cpp/frams/genetics/f1/conv_f1.h	(revision 408)
@@ -19,5 +19,5 @@
 
 /**
- Official framsticks f1 -> f0 converter.
+ Official Framsticks f1 -> f0 converter.
  Source code is published as educational example, but currently not
  well documented.
Index: cpp/frams/model/model.h
===================================================================
--- cpp/frams/model/model.h	(revision 400)
+++ cpp/frams/model/model.h	(revision 408)
@@ -25,7 +25,7 @@
 
 /**
-    "Model" is the skeleton of the framsticks creature.
+    "Model" is the skeleton of the Framsticks creature.
     This object can be used for 2 purposes:
-     - you can build a creature from any supported framsticks genotype
+     - you can build a creature from any supported Framsticks genotype
     format
      - or generate low level f0 genotype from existing construct.
@@ -33,5 +33,5 @@
     In both cases you have access to geometry and neuron net data.
     Using this standard class assures compatibility and good
-    integration with core framsticks engine.
+    integration with core Framsticks engine.
 
     Model contains 3 kinds of objects:
Index: cpp/frams/model/modelparts.h
===================================================================
--- cpp/frams/model/modelparts.h	(revision 400)
+++ cpp/frams/model/modelparts.h	(revision 408)
@@ -62,5 +62,5 @@
 };
 
-/// Part is the only real physical object in the framsticks creature.
+/// Part is the only real physical object in the Framsticks creature.
 /// You can use this class for querying and adjusting constructed
 /// model properties
@@ -84,5 +84,5 @@
 
 ///
-paInt shape;///default=old framsticks compatible, do not mix with shapes>0
+paInt shape;///default=old Framsticks compatible, do not mix with shapes>0
 enum Shape {SHAPE_DEFAULT=0, SHAPE_ELLIPSOID=1, SHAPE_CUBOID=2, SHAPE_CYLINDER=3};
 double mass,size,density,friction,ingest,assim,hollow;
@@ -125,5 +125,5 @@
 class Pt3D rot;	///< orientation delta between parts expressed as 3 angles
 enum Shape {SHAPE_DEFAULT=0, SHAPE_SOLID=1};
-paInt shape;///< default=old framsticks compatible, creates a physical rod between parts (cylinder or cuboid), do not mix with shape>0,  solid=merge parts into one physical entity
+paInt shape;///< default=old Framsticks compatible, creates a physical rod between parts (cylinder or cuboid), do not mix with shape>0,  solid=merge parts into one physical entity
 
 Joint();
@@ -300,5 +300,5 @@
 #endif
 
-/** Single processing unit in framsticks NN.  */
+/** Single processing unit in Framsticks NN.  */
 class Neuro: public PartBase
 {
@@ -343,5 +343,5 @@
     new Neuro can be created as root object (without parent) or can be 
     the child of existing Neuro. Children of the Neuro are its inputs.
-    Standard framsticks neuron calculates the sum of all input units - other processing
+    Standard Framsticks neuron calculates the sum of all input units - other processing
     units don't have to treat them equally and can even ignore some of them.
     There are hints about expected inputs in the class database, @see getClass
@@ -350,5 +350,5 @@
     except for two standard classes: (information about all current classes
     can be retrieved with getClass/getClassProperties methods)
-    - getClassName()="N" is the standard framsticks neuron, accepts any number of inputs,
+    - getClassName()="N" is the standard Framsticks neuron, accepts any number of inputs,
       compatible with old Neuro object
     - getClassName()="-" is the neuron link, compatible with old Neuro-Neuro link